function edges3d(varargin)
%EDGES3D  Description of functions operating on 3D edges.
%
%   A 3D edge is represented by the coordinates of its extremities:
%   EDGE = [X1 Y1 Z1  X2 Y2 Z2];
%
%   A set of 3D edges is represented by a N-by-6 array, each row
%   representing an edge.
%
%   See also
%   lines3d, edges2d, createEdge3d, edgeLength3d
%   intersectEdgePlane, edgeToLine3d, edgeToLine3d, clipEdge3d, midPoint3d
%   distancePointEdge3d, drawEdge3d, drawSphericalEdge
 
% ------
% Author: David Legland
% e-mail: david.legland@inra.fr
% Created: 2018-04-12,    using Matlab 9.3.0.713579 (R2017b)
% Copyright 2018 INRA - Cepia Software Platform.

help('edges3d');
